/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageHeader type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageHeader{}

// MessageHeader struct for MessageHeader
type MessageHeader struct {
	Type MessageHeaderType `json:"type"`
	Text *string `json:"text,omitempty"`
}

// NewMessageHeader instantiates a new MessageHeader object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageHeader(type_ MessageHeaderType) *MessageHeader {
	this := MessageHeader{}
	this.Type = type_
	return &this
}

// NewMessageHeaderWithDefaults instantiates a new MessageHeader object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageHeaderWithDefaults() *MessageHeader {
	this := MessageHeader{}
	return &this
}

// GetType returns the Type field value
func (o *MessageHeader) GetType() MessageHeaderType {
	if o == nil {
		var ret MessageHeaderType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *MessageHeader) GetTypeOk() (*MessageHeaderType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *MessageHeader) SetType(v MessageHeaderType) {
	o.Type = v
}

// GetText returns the Text field value if set, zero value otherwise.
func (o *MessageHeader) GetText() string {
	if o == nil || IsNil(o.Text) {
		var ret string
		return ret
	}
	return *o.Text
}

// GetTextOk returns a tuple with the Text field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageHeader) GetTextOk() (*string, bool) {
	if o == nil || IsNil(o.Text) {
		return nil, false
	}
	return o.Text, true
}

// HasText returns a boolean if a field has been set.
func (o *MessageHeader) HasText() bool {
	if o != nil && !IsNil(o.Text) {
		return true
	}

	return false
}

// SetText gets a reference to the given string and assigns it to the Text field.
func (o *MessageHeader) SetText(v string) {
	o.Text = &v
}

func (o MessageHeader) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageHeader) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	if !IsNil(o.Text) {
		toSerialize["text"] = o.Text
	}
	return toSerialize, nil
}

type NullableMessageHeader struct {
	value *MessageHeader
	isSet bool
}

func (v NullableMessageHeader) Get() *MessageHeader {
	return v.value
}

func (v *NullableMessageHeader) Set(val *MessageHeader) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageHeader) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageHeader) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageHeader(val *MessageHeader) *NullableMessageHeader {
	return &NullableMessageHeader{value: val, isSet: true}
}

func (v NullableMessageHeader) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageHeader) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


